import { IDictionary } from '../type';
import descriptionModal from './descriptionModal';

interface IProps {
  children: string | null;
  dictionary: IDictionary[];
  clickedWord: string;
  pos: { x: number; y: number };
}
function replaceHighlitingWord({ children, dictionary, clickedWord, pos }: IProps) {
  if (!children) return children;
  const keyArr = dictionary.map((item: IDictionary) => item.word);
  let highlightedContent = children;

  keyArr.forEach((word: string) => {
    highlightedContent = highlightedContent.replace(word, match =>
      clickedWord === word ? `${match}` : `<span class="highlight">${match}</span>`,
    );
  });

  keyArr.forEach((word: string, index: number) => {
    highlightedContent = highlightedContent.replace(word, match =>
      clickedWord === word ? `${descriptionModal({ index, dictionary, match, pos })}` : `${match}`,
    );
  });
  return highlightedContent;
}

export default replaceHighlitingWord;
